=== modified file 'lib/lp/bugs/configure.zcml'
--- lib/lp/bugs/configure.zcml	2011-08-04 20:31:30 +0000
+++ lib/lp/bugs/configure.zcml	2011-08-11 15:00:31 +0000
@@ -114,9 +114,6 @@
         for="lp.bugs.interfaces.bugsubscription.IBugSubscription                 lazr.lifecycle.interfaces.IObjectCreatedEvent"
         handler="lp.bugs.subscribers.bug.notify_bug_subscription_added"/>
     <subscriber
-        for="lp.bugs.interfaces.bug.IBug                 lp.bugs.interfaces.bug.IDeferredObjectModifiedEvent"
-        handler="lp.bugs.subscribers.bug.deferred_notify_bug_modified"/>
-    <subscriber
         for="lp.bugs.interfaces.bug.IBug                 lazr.lifecycle.interfaces.IObjectModifiedEvent"
         handler="lp.bugs.subscribers.bug.notify_bug_modified"/>
     <securedutility

=== modified file 'lib/lp/bugs/interfaces/bug.py'
--- lib/lp/bugs/interfaces/bug.py	2011-08-04 20:31:30 +0000
+++ lib/lp/bugs/interfaces/bug.py	2011-08-11 15:00:31 +0000
@@ -16,7 +16,6 @@
     'IBugDelta',
     'IBugMute',
     'IBugSet',
-    'IDeferredObjectModifiedEvent',
     'IFileBugData',
     'IFrontPageBugAddForm',
     'IProjectGroupBugAddForm',
@@ -1243,7 +1242,3 @@
     date_created = Datetime(
         title=_("The date on which the mute was created."), required=False,
         readonly=True)
-
-
-class IDeferredObjectModifiedEvent(IObjectModifiedEvent):
-    pass

=== modified file 'lib/lp/bugs/model/bug.py'
--- lib/lp/bugs/model/bug.py	2011-08-11 13:47:05 +0000
+++ lib/lp/bugs/model/bug.py	2011-08-11 15:00:31 +0000
@@ -137,7 +137,6 @@
     IBugMute,
     IBugSet,
     IFileBugData,
-    IDeferredObjectModifiedEvent,
     )
 from lp.bugs.interfaces.bugactivity import IBugActivitySet
 from lp.bugs.interfaces.bugattachment import (
@@ -240,10 +239,6 @@
     tag = StringCol(notNull=True)
 
 
-class DeferredObjectModifiedEvent(ObjectModifiedEvent):
-    implementsOnly(IDeferredObjectModifiedEvent)
-
-
 def get_bug_tags(context_clause):
     """Return all the bug tags as a list of strings.
 
@@ -1829,35 +1824,21 @@
             if duplicate_of is not None:
                 field._validate(duplicate_of)
             if self.duplicates:
+                user = getUtility(ILaunchBag).user
                 for duplicate in self.duplicates:
-                    ## # Fire a notify event in model code since moving
-                    ## # duplicates of a duplicate does not normally fire an
-                    ## # event.
-                    ## dupe_before = Snapshot(
-                    ##     duplicate, providing=providedBy(duplicate))
-
                     old_value = duplicate.duplicateof
-                    new_value = duplicate_of
                     affected_targets.update(
                         duplicate._markAsDuplicate(duplicate_of))
 
-                    ## # At this point the event must be marked to indicate it
-                    ## # should not gather the recipents but be a deferred
-                    ## # event.
-                    ## event = DeferredObjectModifiedEvent(
-                    ##    duplicate, dupe_before, 'duplicateof')
-                    ## notify(event)
-
-                    # Directly put an entry into the BugNotification table for
+                    # Put an entry into the BugNotification table for
                     # later processing.
-                    user = getUtility(ILaunchBag).user
                     change = DeferredBugDuplicateChange(
                         when=None, person=user,
                         what_changed='duplicateof',
                         old_value=old_value,
-                        new_value=new_value)
-                    recipients = BugNotificationRecipients()
-                    duplicate.addChange(change, recipients)
+                        new_value=duplicate_of)
+                    empty_recipients = BugNotificationRecipients()
+                    duplicate.addChange(change, empty_recipients)
 
             self.duplicateof = duplicate_of
         except LaunchpadValidationError, validation_error:

=== modified file 'lib/lp/bugs/model/tests/test_bug.py'
--- lib/lp/bugs/model/tests/test_bug.py	2011-08-11 13:47:05 +0000
+++ lib/lp/bugs/model/tests/test_bug.py	2011-08-11 15:00:31 +0000
@@ -177,8 +177,6 @@
             Store.of(bug).flush()
             with StormStatementRecorder() as recorder:
                 previous_dup.markAsDuplicate(bug)
-                print "num queries = ", recorder.count
-                #self.analyze_queries(recorder.queries)
                 self.assertThat(recorder, HasQueryCount(LessThan(100)))
 
     def test_get_subscribers_from_duplicates_with_private_team(self):

=== modified file 'lib/lp/bugs/subscribers/bug.py'
--- lib/lp/bugs/subscribers/bug.py	2011-08-04 18:03:37 +0000
+++ lib/lp/bugs/subscribers/bug.py	2011-08-11 15:00:31 +0000
@@ -26,7 +26,6 @@
 from canonical.launchpad.webapp.publisher import canonical_url
 from lp.bugs.adapters.bugchange import (
     BugDuplicateChange,
-    DeferredBugDuplicateChange,
     BugTaskAssigneeChange,
     get_bug_changes,
     )
@@ -63,20 +62,6 @@
 
 
 @block_implicit_flushes
-def deferred_notify_bug_modified(bug, event):
-    """Handle bug change events where the notifications should be deferred.
-
-    This handler will queue up a notice about the change but the computation
-    of recipients happens later in the cronscript.
-    """
-    bug_delta = get_bug_delta(
-        old_bug=event.object_before_modification,
-        new_bug=event.object, user=IPerson(event.user))
-    if bug_delta is not None:
-        add_deferred_bug_change_notifications(bug_delta)
-
-
-@block_implicit_flushes
 def notify_bug_comment_added(bugmessage, event):
     """Notify CC'd list that a message was added to this bug.
 
@@ -198,23 +183,6 @@
             bug_delta.bug.addChange(change, recipients=recipients)
 
 
-def add_deferred_bug_change_notifications(bug_delta, old_bugtask=None,
-                                          new_subscribers=None):
-    """Generate deferred bug notification.
-
-    These notifications provide all of the necessary information except the
-    recipient list which is too costly to generate during the request.
-    """
-    changes = get_bug_changes(bug_delta)
-    recipients = BugNotificationRecipients()
-    for change in changes:
-        if isinstance(change, BugDuplicateChange):
-            deferred_change = DeferredBugDuplicateChange(
-                change.when, change.person, change.what_changed,
-                change.old_value, change.new_value)
-            bug_delta.bug.addChange(deferred_change, recipients=recipients)
-
-
 def send_bug_details_to_new_bug_subscribers(
     bug, previous_subscribers, current_subscribers, subscribed_by=None,
     event_creator=None):

